 
/* Include any standard system header files */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

/* Include the isdc.h header file */

#ifndef ISDC_INCLUDED
#include <isdc.h>
#endif

/* Include other ISDC system library header files */

#ifndef DAL_INCLUDED
#include <dal.h>
#endif

#ifndef PIL_INCLUDED
#include <pil.h>
#endif

#ifndef RIL_INCLUDED
#include <ril.h>
#endif

/* DAL3AUX optional library                                                  */
#include <dal3aux.h>

/* SLALIB astronomical library
#include <slalib.h>

/* Subroutines for the user supplied analysis executable functions */
#include<iostream.h>
#include "include.h"             /* prototypes of functions */
#include "parameters.h"  /* class definition */

 



#include"read_SPI_OBS_DSP.h"
#include"read_EBDS.h"
#include"read_DTI.h"
#include"write_SPI_BMOD_DSP.h"
//////////////////////////////////////////////////////////////////////////////////////

 int index(int i_chi,int i_psi, int i_energy, int n_chi, int n_psi, int n_energy)
          {return i_energy*n_chi*n_psi+i_psi*n_chi + i_chi;}

//////////////////////////////////////////////////////////////////////////////////////

int processing      ( ){

extern parameters parameters; /* global, defined in parameters.cc */


RILlogMessage(NULL,Log_1," processing begins "       );

int status=0;
int verbose=0;
 
CSPE    cspe_ON;
CSPE    cspe_OFF;

EBDS    ebds;
DTI     dti_ON;
DTI     dti_OFF;

BACK    back;

int numChild;
numChild=2; // ON events in first SPI-OBS-DSP dataset, which is #2  in common_group

cspe_ON =read_SPI_OBS_DSP(parameters.common_group,numChild, parameters.debug);

 if(parameters.debug>0)
 {
RILlogMessage(NULL,Log_1," +++++++++++++++ ON  spectra +++++++++++++++    "       );
cspe_ON.print();
}

numChild=3; // OFF events in second SPI-OBS-DSP dataset, which is #3 in common_group

cspe_OFF =read_SPI_OBS_DSP(parameters.common_group,numChild, parameters.debug);

 if(parameters.debug>0)
 {
RILlogMessage(NULL,Log_1," +++++++++++++++ OFF spectra +++++++++++++++    "       );
cspe_OFF.print();
}

ebds =read_EBDS       (parameters.common_group, parameters.debug);
 if(parameters.debug>0)
 {
ebds.print();
}

 dti_ON =read_DTI        (parameters.common_group, parameters.debug);
 if(parameters.debug>0)
 {
 dti_ON.print();
}


 
int i_energy, i_pointing, i_detector,i_comp;
int index;
 
 double counts_ON;
 double counts_OFF;
 double total_counts_ON;
 double total_counts_back;
 

 double energy_mean;
 double energy_bin;

 double ON_livetime; 

 back.numofd=cspe_ON.numofd;
 back.numofp=cspe_ON.numofp;
 back.numofe=cspe_ON.numofe;
 back.n_components=1;

 
 back.counts=new float[back.numofd*back.numofp*back.numofe*back.n_components];                             //AWS20030506
 for (index=0;   index<back.numofd*back.numofp*back.numofe*back.n_components;index++)back.counts[index]=0.;//AWS20030506


 for(i_energy=0;i_energy<cspe_ON.numofe;i_energy++)
 {


  for(i_detector=0;i_detector<cspe_ON.numofd;i_detector++)
  {
   counts_ON =0;
   counts_OFF=0;
   for(i_pointing=0;i_pointing<cspe_ON.numofp;i_pointing++)
   {
    counts_ON +=cspe_ON. counts
               [index_count(i_energy,i_detector,i_pointing,cspe_ON.numofe,cspe_ON.numofd, cspe_ON.numofp) ];

   } //i_pointing

  
  counts_OFF=0;

  for(i_pointing=0;i_pointing<cspe_OFF.numofp;i_pointing++)
  {
   counts_OFF+=cspe_OFF.counts
               [index_count(i_energy,i_detector,i_pointing,cspe_ON.numofe,cspe_ON.numofd, cspe_OFF.numofp) ];

//cout<<cspe_OFF.counts[index_count(i_energy,i_detector,i_pointing,cspe_ON.numofe,cspe_ON.numofd, cspe_ON.numofp) ]<<" "<< index_count(i_energy,i_detector,i_pointing,cspe_ON.numofe,cspe_ON.numofd, cspe_ON.numofp)<<" "<<i_energy<<" "<<i_detector<<" "<<i_pointing<<endl;

   } //i_pointing


  

 
  for(i_pointing=0;i_pointing<cspe_ON.numofp;i_pointing++)
    {

    ON_livetime=dti_ON.livetime[i_detector+i_pointing*back.numofd];

    i_comp=0;
    back.counts[index_back(i_energy,i_detector,i_pointing,i_comp,back.numofe,back.numofd, back.numofp,back.n_components)]
       =counts_OFF*ON_livetime;
    
  // cout<<"ON_livetime="<<ON_livetime<<endl;
}

}// i_detector

 
  //normalize to total ON counts in this energy range
  total_counts_ON=0.;
  total_counts_back=0;

  for(i_detector=0;i_detector<cspe_ON.numofd;i_detector++)
  {
     for(i_pointing=0;i_pointing<cspe_ON.numofp;i_pointing++)
   {
    total_counts_ON   +=cspe_ON. counts
               [index_count(i_energy,i_detector,i_pointing,cspe_ON.numofe,cspe_ON.numofd, cspe_ON.numofp) ];

    total_counts_back +=
      back.counts[index_back(i_energy,i_detector,i_pointing,i_comp,back.numofe,back.numofd, back.numofp,back.n_components)];

   } //i_pointing
  }
 

  for(i_detector=0;i_detector<cspe_ON.numofd;i_detector++)
  {
     for(i_pointing=0;i_pointing<cspe_ON.numofp;i_pointing++)
   {
 
      back.counts[index_back(i_energy,i_detector,i_pointing,i_comp,back.numofe,back.numofd, back.numofp,back.n_components)]
	*=total_counts_ON/total_counts_back;

   } //i_pointing
  }
 


  if(parameters.debug>0)
  cout<<"energy_mean="<<energy_mean<<"  total counts ON="<<counts_ON<<"  total counts OFF="<<counts_OFF<<endl;

 } //i_energy

  
 if(parameters.debug>0)
 back.print();
  
 write_SPI_BMOD_DSP   (parameters.common_group,back.  counts,back.numofd,back.numofp,back.numofe ,back.n_components,parameters.debug);


RILlogMessage(NULL,Log_1," processing ends "       );
 
 
return status;}
