 
/* Include any standard system header files */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

/* Include the isdc.h header file */

#ifndef ISDC_INCLUDED
#include <isdc.h>
#endif

/* Include other ISDC system library header files */

#ifndef DAL_INCLUDED
#include <dal.h>
#endif

#ifndef PIL_INCLUDED
#include <pil.h>
#endif

#ifndef RIL_INCLUDED
#include <ril.h>
#endif



/* Subroutines for the user supplied analysis executable functions */
#include<iostream.h>


#include"DTI.h"

 

 

DTI     read_DTI   (dal_element *common_group,int debug) {
   
  

 if(debug>0)cout<<">>>> read_DTI"<<endl;

  int status    = ISDC_OK;
  
  DTI dti;



  char msg [DAL_BIG_STRING];
  char name[DAL_BIG_STRING];
  dal_baseType baseType;

  dal_element *object1 = NULL;
  
  dal_element *element = NULL;
  

int colIndex=0; // since use column name
long numRows;      ;
 

int i;
  

void *buff=NULL;
long numValues;

     

dal_element *object2 = NULL;
 
element=NULL;
status = DALobjectFindElement(common_group,"SPI.-OBS.-DTI",&element,status);
if(debug>=1)cout<<"DALobjectFindElement status="<<status<<endl;

void *value;
char    unit[DAL_BIG_STRING];  
char comment[DAL_BIG_STRING];

strcpy(name,"ISOC_NUM"); //AWS20010316

value=&dti.ISOC_NUM;     //AWS20010316
status=DALattributeGet(element,name,DAL_INT,value,unit,comment,status);
if(debug>=1)cout<<"DALattributeGet      status="<<status<<endl;
if(debug>=1)cout<<name<<"="<<dti.ISOC_NUM <<endl; //AWS20010316

strcpy(name,"PT_NUM");

value=&dti.PT_NUM;
status=DALattributeGet(element,name,DAL_INT,value,unit,comment,status);
if(debug>=1)cout<<"DALattributeGet      status="<<status<<endl;
if(debug>=1)cout<<name<<"="<<dti.PT_NUM <<endl;

strcpy(name,"DET_NUM");

value=&dti.DET_NUM;
status=DALattributeGet(element,name,DAL_INT,value,unit,comment,status);
if(debug>=1)cout<<"DALattributeGet      status="<<status<<endl;
if(debug>=1)cout<<name<<"="<< dti.DET_NUM<<endl;


numRows=0;
status = DALtableGetNumRows(element,&numRows,status);
if(debug>=1)cout<<"DALtableGetNumRows status="<<status<<endl;
if(debug>=1)cout<<"numRows ="<<numRows<<endl;

double *deadtime = new double[numRows];
double *livetime = new double[numRows];
 
 


long buffSize;
long startRow=1;
long   endRow=numRows;

status = DALtableComputeBuffSize(element,"DEADRATIO",colIndex,startRow,endRow,&buffSize,status);
if(debug>=1)cout<<  "DALtableComputeBuffSize status="<<status<<" buffSize="<<buffSize<<endl;

status = DALallocateDataBuffer(&buff,buffSize,status);
if(debug>=1)cout<<  "DALtableallocateDataBuffer status="<<status<<endl;



dal_dataType dataType=DAL_DOUBLE;


 


 



// read  entire column: all rows and all column bins
buff=deadtime;
 status = DALtableGetCol(element,"DEADRATIO",colIndex,&dataType,&numValues,buff,status); //AWS20010316
   if(status!=0)cout<<"DALtableGetCol status="<<status<<endl;
buff=livetime;
status = DALtableGetCol(element,"LIVETIME",colIndex,&dataType,&numValues,buff,status);
    if(status!=0)  cout<<"DALtableGetCol status="<<status<<endl;
 
 

  

   if(debug>=1)
     for ( i=0;i<numRows;i++){cout<<" DEADRATIO="<<deadtime[i]<<" LIVETIME ="<<livetime [i]<<endl;}//AWS20010316



 

     status = DALobjectClose(object2,DAL_SAVE,status);
     if(debug>=1)cout<<  "DALobjectClose status="<<status<<endl;





dti . deadtime=new double[numRows];
dti . livetime=new double[numRows];
 


 for ( i=0;i<numRows;i++){
dti .  deadtime[i]=deadtime[i]; 
dti .  livetime[i]=livetime[i];               
               
 }



 if(debug>0)cout<<"<<<< read_DTI"<<endl;
   
 
return dti;}


 
