 
/* Include any standard system header files */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include<iostream.h>

/* Include the isdc.h header file */

#ifndef ISDC_INCLUDED
#include <isdc.h>
#endif

/* Include other ISDC system library header files */

#ifndef DAL_INCLUDED
#include <dal.h>
#endif

#ifndef PIL_INCLUDED
#include <pil.h>
#endif

#ifndef RIL_INCLUDED
#include <ril.h>
#endif

#include"CSPE.h"



CSPE   read_SPI_OBS_DSP   (dal_element *common_group,int debug ){
   
   
RILlogMessage(NULL,Log_1,"read_SPI_OBS_DSP begins "       );
 

 
  int status    = ISDC_OK;
  
  
  char msg [DAL_BIG_STRING];
  char name[DAL_BIG_STRING];
  dal_baseType baseType;

  dal_element *object1 = NULL;
  
  dal_element *element = NULL;
  
  
 
int colIndex=0; // since use column name

 
 int i;
   //for (i=0;i<binSize*numRows;i++)cout<<counts[i];cout<<endl;

void *counts_buff=NULL;






/*
 dal_element *object2 = NULL;
strcpy(name,counts_file);
strcat(name,".fits[SPI.-CSPE-OSR]"); // works: [EXTNAME]
if(debug>=1) cout<<"opening "<<name<<endl;
status = DALobjectOpen(name,&object2,status);
if(debug>=1)cout<<  "DALobjectOpen status="<<status<<endl;
*/
element=NULL;
status = DALobjectFindElement(common_group,"SPI.-OBS.-DSP",&element,status);
if(debug>=1)cout<<"DALobjectFindElement status="<<status<<endl;

 

 



dal_dataType dataType=DAL_LONG;
long numRows=0;
long binSize=0;
int varLength;
status = DALtableGetColStruct(element,colIndex,&numRows,"COUNTS",&dataType,&binSize,&varLength,status);
if(debug>=1)cout<<"DALtableGetColStruct status="<<status<<endl;
if(debug>=1)cout<<"numRows ="<<numRows<<endl;
if(debug>=1)cout<<"binSize ="<<binSize<<endl;
long buffSize;
long startRow=1;
long   endRow=numRows;// since adding an entire column (all rows)

 dataType=DAL_LONG; // required output
status = DALtableComputeBuffSize(element,"COUNTS",colIndex,startRow,endRow,&buffSize,status);
if(debug>=1)cout<<  "DALtableComputeBuffSize status="<<status<<" buffSize="<<buffSize<<endl;

status = DALallocateDataBuffer(&counts_buff,buffSize,status);
if(debug>=1)cout<<  "DALtableallocateDataBuffer status="<<status<<endl;


long numValues;
numValues=binSize*numRows;

long *counts=new long[numValues];
int numofd; 
int numofp;
int numofe;


char    unit[DAL_BIG_STRING];  
char comment[DAL_BIG_STRING];

strcpy(name,"DET_NUM");
void *value;
value=&numofd;
status=DALattributeGet(element,name,DAL_INT,value,unit,comment,status);
if(debug>=1)cout<<"NUMOFD="<< numofd<<endl;

strcpy(name,"PT_NUM");
value=&numofp;
status=DALattributeGet(element,name,DAL_INT,value,unit,comment,status);
if(debug>=1)cout<<"NUMOFP="<< numofp<<endl;

strcpy(name,"EBIN_NUM");
value=&numofe;
status=DALattributeGet(element,name,DAL_INT,value,unit,comment,status);
if(debug>=1)cout<<"NUMOFE="<< numofe<<endl;

for ( i=0;i<binSize*numRows;i++)counts[i]=0;
  
dataType=DAL_LONG;
counts_buff=counts;
status=0;
// read  entire column: all rows and all column bins
 status = DALtableGetCol(element,"COUNTS",colIndex,&dataType,&numValues,counts_buff,status);
 if(debug>=1)  cout<<"DALtableGetCol status="<<status<<endl;


   


   // print according to indexing scheme
 if(debug>=1) {
   for(int i_point=0 ;i_point <numofp ;i_point++ ){
   for(int i_energy=0;i_energy<numofe; i_energy++){
    cout<<" detector counts read for pointing #"
     <<i_point<<" energy#"<<i_energy<<endl;
     for(int idet=0;   idet   <numofd ;idet++    )
      cout<<counts
          [index_count(i_energy,idet,i_point,numofe, numofd, numofp)]<<" ";
      cout<<endl;
   }//debug
   }
   }

CSPE cspe;
cspe.numofd=numofd;
cspe.numofp=numofp;
cspe.numofe=numofe;

cspe.counts=new long[numofd*numofp*numofe];
for (    i=0;i<numofd*numofp*numofe;i++)cspe.counts[i]=counts[i];

 
 
  
RILlogMessage(NULL,Log_1,"read_SPI_OBS_DSP ends "       );
  
 
return cspe  ;}

/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
 
CSPE   read_SPI_OBS_DSP   (dal_element *common_group,int numChild, int debug ){
   
  // same routine but reads Child #numChild (for case of more than one SPI.-OBS.-DSP in parameter file
  
RILlogMessage(NULL,Log_1,"read_SPI_OBS_DSP begins (numChild) "       );
 

 
  int status    = ISDC_OK;
  
  
  char msg [DAL_BIG_STRING];
  char name[DAL_BIG_STRING];
  dal_baseType baseType;

  dal_element *object1 = NULL;
  
  dal_element *element = NULL;
  
  
 
int colIndex=0; // since use column name

 
 int i;
   //for (i=0;i<binSize*numRows;i++)cout<<counts[i];cout<<endl;

void *counts_buff=NULL;

element=NULL;
 
dal_accessType *atype   = NULL; // important to initialize to NULL: otherwise causes problem
dal_baseType   *basetype= NULL;

 status=DALelementGetChild(common_group,numChild,&element,atype,basetype,status);
if(status!=0)cout<<"DALelementGetChild   status="<<status<<endl;

 



dal_dataType dataType=DAL_LONG;
long numRows=0;
long binSize=0;
int varLength;
status = DALtableGetColStruct(element,colIndex,&numRows,"COUNTS",&dataType,&binSize,&varLength,status);
if(debug>=1)cout<<"DALtableGetColStruct status="<<status<<endl;
if(debug>=1)cout<<"numRows ="<<numRows<<endl;
if(debug>=1)cout<<"binSize ="<<binSize<<endl;
long buffSize;
long startRow=1;
long   endRow=numRows;// since adding an entire column (all rows)

 dataType=DAL_LONG; // required output
status = DALtableComputeBuffSize(element,"COUNTS",colIndex,startRow,endRow,&buffSize,status);
if(debug>=1)cout<<  "DALtableComputeBuffSize status="<<status<<" buffSize="<<buffSize<<endl;

status = DALallocateDataBuffer(&counts_buff,buffSize,status);
if(debug>=1)cout<<  "DALtableallocateDataBuffer status="<<status<<endl;


long numValues;
numValues=binSize*numRows;

long *counts=new long[numValues];
int numofd; 
int numofp;
int numofe;


char    unit[DAL_BIG_STRING];  
char comment[DAL_BIG_STRING];

strcpy(name,"DET_NUM");
void *value;
value=&numofd;
status=DALattributeGet(element,name,DAL_INT,value,unit,comment,status);
if(debug>=1)cout<<"NUMOFD="<< numofd<<endl;

strcpy(name,"PT_NUM");
value=&numofp;
status=DALattributeGet(element,name,DAL_INT,value,unit,comment,status);
if(debug>=1)cout<<"NUMOFP="<< numofp<<endl;

strcpy(name,"EBIN_NUM");
value=&numofe;
status=DALattributeGet(element,name,DAL_INT,value,unit,comment,status);
if(debug>=1)cout<<"NUMOFE="<< numofe<<endl;

for ( i=0;i<binSize*numRows;i++)counts[i]=0;
  
dataType=DAL_LONG;
counts_buff=counts;
status=0;
// read  entire column: all rows and all column bins
 status = DALtableGetCol(element,"COUNTS",colIndex,&dataType,&numValues,counts_buff,status);
 if(debug>=1)  cout<<"DALtableGetCol status="<<status<<endl;


   


   // print according to indexing scheme
 if(debug>=1) {
   for(int i_point=0 ;i_point <numofp ;i_point++ ){
   for(int i_energy=0;i_energy<numofe; i_energy++){
    cout<<" detector counts read for pointing #"
     <<i_point<<" energy#"<<i_energy<<endl;
     for(int idet=0;   idet   <numofd ;idet++    )
      cout<<counts
          [index_count(i_energy,idet,i_point,numofe, numofd, numofp)]<<" ";
      cout<<endl;
   }//debug
   }
   }

CSPE cspe;
cspe.numofd=numofd;
cspe.numofp=numofp;
cspe.numofe=numofe;

cspe.counts=new long[numofd*numofp*numofe];
for (    i=0;i<numofd*numofp*numofe;i++)cspe.counts[i]=counts[i];

 
 
  
RILlogMessage(NULL,Log_1,"read_SPI_OBS_DSP (numChild ) ends "       );
  
 
return cspe  ;}


 
