/******************************************************************************

  File name:  spioffback_main.cc
  Version:    2.0
  Component:  SPI ISSW for ISDC                       
  Developer:  Andrew Strong ISDC
              aws@mpe.mpg.de               
  
  Purpose:

  Combined observations after spihist level into since observation group.
                                            
                                                                               
   

  Revision History: 
 
    version  1 24 Nov 2002 AWS    created 
    version  2 06 May 2003 AWS  
 ******************************************************************************/

/* 
 * Include the analysis component header file
 */

#include "include.h"           


/* 
 * Define C pre-preprocessor parameters local to this file
 */

#define COMPONENT_NAME    "spioffback"           
#define COMPONENT_VERSION "2.0"
#define LEN_FILE_NAME      120

/*****************************************************************************

  Function: main

  Description:
      
     This is the main function 

  Error codes:

     0 == ISDC_OK ==> function executed with no errors
     < 0          ==> function terminated with an error

  Parameter arguments:

     name        type    I/O       description

     argc        int     input     number of command line arguments
     argv        char**  input     char array of comman line arguments

*****************************************************************************/

main(int argc, char *argv[])
{
  int status = ISDC_OK;            /* internal status flag                  */
  int mode;                        /* mode (single, server) of task         */

 
  mode = CommonInit(COMPONENT_NAME,COMPONENT_VERSION,argc,argv);
	 
  if(mode != ISDC_SINGLE_MODE && mode != ISDC_SERVER_MODE)  status = mode;
	
  status=ISDC_OK;                                                                   
  RILlogMessage(NULL,Log_1,"=============================================",status); 
  RILlogMessage(NULL,Log_1,"|  spioffback Version  2.0         May 2003  |",status); 
  RILlogMessage(NULL,Log_1,"|  Generate background from OFF observation  |",status); 
  RILlogMessage(NULL,Log_1,"|                                            |",status); 
  RILlogMessage(NULL,Log_1,"|  Developed by A. Strong,  aws@mpe.mpg.de   |",status); 
  RILlogMessage(NULL,Log_1,"|  Please contact me for questions/problems  |",status); 
  RILlogMessage(NULL,Log_1,"=============================================",status); 
      
	  /* process the input data sets */
 if(status==ISDC_OK)            
       status = get_par();

	  
 if(status==ISDC_OK)            
       status = processing();
	   
 RILlogMessage(NULL,Log_1,"========= spioffback Version 2.0 run completed with status %d",status, status); 
	 
  /*
   * call the CommonExit() function to clean up and terminate the task
   */
	   
 CommonExit(status);  //  removed to avoid root problem
}

