 
/* Include any standard system header files */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

/* Include the isdc.h header file */

#ifndef ISDC_INCLUDED
#include <isdc.h>
#endif

/* Include other ISDC system library header files */

#ifndef DAL_INCLUDED
#include <dal.h>
#endif

#ifndef PIL_INCLUDED
#include <pil.h>
#endif

#ifndef RIL_INCLUDED
#include <ril.h>
#endif



/* Subroutines for the user supplied analysis executable functions */
#include<iostream.h>
 
#include"index_count.h"



int    write_SPI_BMOD_DSP   (dal_element *common_group,float *counts,int numofd, int numofp, int numofe ,int n_components,int debug){
   
 
 if(debug>0)cout<<">>>> write_SPI_BMOD_DSP"<<endl;

 
  int status    = ISDC_OK;
  
  
  char msg [DAL_BIG_STRING];
  char name[DAL_BIG_STRING];
  dal_baseType baseType;

  dal_element *object1 = NULL;
  
  dal_element *element = NULL;
  
  

 
 
 status = DALobjectFindElement(common_group,"SPI.-BMOD-DSP",&element,status);
 if(status!=0)cout<<"DALobjectFindElement status="<<status<<endl;

  status = DALelementGetBaseType(element,&baseType,status);
if(debug>0)cout<<DAL_ARRAY<<" "<<DAL_TABLE<<" "<<DAL_INFO<<" "<<DAL_GROUP<<" our baseType= "<<baseType<<endl;

 
  
int colIndex=0; // since use column name

 

long binSize=numofe; 
status = DALtableAddCol(element,"COUNTS",DAL_FLOAT,binSize,status);
if(status!=0)cout<<  "DALtableAddCol status="<<status<<endl;
status = DALtableSetColUnits(element,"COUNTS",colIndex,"count",status);
if(status!=0)cout<<  "DALtableAddCol status="<<status<<endl;


 
long numRows=numofd*numofp;
status = DALtableAddRows(element,0,numRows,status);
if(status!=0)cout<<  "DALtableAddRows status="<<status<<endl;

int i;
   //for (i=0;i<binSize*numRows;i++)cout<<counts[i];cout<<endl;

void *counts_buff=NULL;

long buffSize;
long startRow=1;
long   endRow=numRows;// since adding an entire column (all rows)

status = DALtableComputeBuffSize(element,"COUNTS",colIndex,startRow,endRow,&buffSize,status);
if(status!=0)cout<<  "DALtableComputeBuffSize status="<<status<<" buffSize="<<buffSize<<endl;

status = DALallocateDataBuffer(&counts_buff,buffSize,status);
if(status!=0)cout<<  "DALtableallocateDataBuffer status="<<status<<endl;


long numValues;
numValues=binSize*numRows;




counts_buff=counts;// cast as required

// write entire column: all rows and all column bins
status = DALtablePutCol(element,"COUNTS",colIndex,DAL_FLOAT,numValues,counts_buff,status);
if(status!=0)cout<<"DALtablePutCol status="<<status<<endl;

// ================ STAT_ERR  column
 float *stat_err=new float[binSize*numRows];
 for (i=0;i<binSize*numRows;i++)stat_err[i]=sqrt(float(counts[i])); // grausam

status = DALtableAddCol(element,"STAT_ERR",DAL_FLOAT,binSize,status);
if(status!=0)cout<<  "DALtableAddCol status="<<status<<endl;
status = DALtableSetColUnits(element,"STAT_ERR",colIndex,"count",status);
if(status!=0)cout<<  "DALtableAddCol status="<<status<<endl;


status = DALtableComputeBuffSize(element,"STAT_ERR",colIndex,startRow,endRow,&buffSize,status);
if(status!=0)cout<<  "DALtableComputeBuffSize status="<<status<<" buffSize="<<buffSize<<endl;

counts_buff=stat_err;// cast as required
status = DALallocateDataBuffer(&counts_buff,buffSize,status);
if(status!=0)cout<<  "DALtableallocateDataBuffer status="<<status<<endl;

// write entire column: all rows and all column bins
status = DALtablePutCol(element,"STAT_ERR",colIndex,DAL_FLOAT,numValues,counts_buff,status);
if(status!=0)cout<<"DALtablePutCol status="<<status<<endl;

// ================ keywords

char keyword_name[DAL_BIG_STRING];
char unit        [DAL_BIG_STRING];
char comment     [DAL_BIG_STRING];
strcpy(keyword_name,"DET_NUM");
strcpy(unit," "    );


int* value;
value=&numofd;
status=ISDC_OK  ;
status=DALattributePut(element,keyword_name,DAL_INT,value,unit,NULL   ,status);
//if(status!=0)
cout<<"DALtableattribute Put status="<<status<<endl;


strcpy(keyword_name,"PT_NUM");// number of pointings
strcpy(unit," "    );


value=&numofp;
status=ISDC_OK  ;
status=DALattributePut(element,keyword_name,DAL_INT,value,unit,NULL   ,status);
if(status!=0)cout<<"DALtableattribute Put status="<<status<<endl;

 strcpy(keyword_name,"ISOC_NUM");// number of Science Windows set to  number of pointings //AWS20010316
status=ISDC_OK  ;
status=DALattributePut(element,keyword_name,DAL_INT,value,unit,NULL   ,status);
if(status!=0)cout<<"DALtableattribute Put status="<<status<<endl;


strcpy(keyword_name,"EBIN_NUM");
strcpy(unit," "    );


value=&numofe;
status=ISDC_OK  ;
status=DALattributePut(element,keyword_name,DAL_INT,value,unit,NULL   ,status);
if(status!=0)cout<<"DALtableattribute Put status="<<status<<endl;


/*
// copy keywords from SPI.-OBS.-DTI to SPI.-OBS.-DSP
status=ISDC_OK  ;
 status=copy_keywords(common_group, debug);
if(status!=0)cout<<"copy_keywords status="<<status<<endl;
*/

 status=CommonStampObject(element,"Count Spectra",status);



//status = DALobjectClose(object1,DAL_SAVE,status);
if(status!=0)cout<<  "DALobjectClose status="<<status<<endl;







/*

 if(debug>0){
     // test read of output dataset
     cout<<" ================ test read of counts output file "<<name<<endl;

dal_element *object2 = NULL;
strcpy(name,parameters.counts_output_file);
strcat(name,".fits[SPI.-OBS.-DSP]"); // works: [EXTNAME]
 cout<<"opening "<<name<<endl;
status = DALobjectOpen(name,&object2,status);
cout<<  "DALobjectOpen status="<<status<<endl;

element=NULL;
status = DALobjectFindElement(object2,"SPI.-OBS.-DSP",&element,status);
cout<<"DALobjectFindElement status="<<status<<endl;

baseType=DAL_ARRAY; // set to incorrect value to test whether read correctly
status = DALelementGetBaseType(element,&baseType,status);
cout<<DAL_ARRAY<<" "<<DAL_TABLE<<" "<<DAL_INFO<<" "<<DAL_GROUP<<" our baseType= "<<baseType<<endl;

numRows=0;
status = DALtableGetNumRows(element,&numRows,status);
cout<<"DALtableGetNumRows status="<<status<<endl;
cout<<"numRows ="<<numRows<<endl;

dal_dataType dataType=DAL_LONG;
numRows=0;
binSize=0;
int varLength;
status = DALtableGetColStruct(element,colIndex,&numRows,"COUNTS",&dataType,&binSize,&varLength,status);
cout<<"DALtableGetColStruct status="<<status<<endl;
cout<<"numRows ="<<numRows<<endl;
cout<<"binSize ="<<binSize<<endl;


for ( i=0;i<binSize*numRows;i++)counts[i]=0;
for ( i=0;i<binSize*numRows;i++)cout<<counts[i];cout<<endl;



// read  entire column: all rows and all column bins
 status = DALtableGetCol(element,"COUNTS",colIndex,&dataType,&numValues,counts_buff,status);
   cout<<"DALtableGetCol status="<<status<<endl;


   //for ( i=0;i<binSize*numRows;i++)cout<<counts[i]<<" ";cout<<endl;


   // print according to indexing scheme
   for(int i_point=0 ;i_point <numofp ;i_point++ ){


   for(int i_energy=0;i_energy<numofe; i_energy++){
     cout<<" detector counts read for pointing #"<<i_point<<" energy#"<<i_energy<<endl;
     for(int idet=0;   idet   <numofd ;idet++    )
         cout<<counts[index_count(i_energy,idet,i_point,numofe, numofd, numofp)]<<" ";
     cout<<endl;

   }
   }




     status = DALobjectClose(object2,DAL_SAVE,status);
     cout<<  "DALobjectClose status="<<status<<endl;

 } // test read 


*/
 if(debug>0)cout<<"<<<< write_SPI_BMOD_DSP"<<endl;
   
 
return status;}


 
